//go:build unit
// +build unit

/*
Copyright 2021 The Dapr Authors
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
    http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by mockery v1.0.0.

package actors

import (
	"context"

	mock "github.com/stretchr/testify/mock"

	v1 "github.com/dapr/dapr/pkg/messaging/v1"
	daprt "github.com/dapr/dapr/pkg/testing"
)

// MockActors is an autogenerated mock type for the Actors type
type MockActors struct {
	mock.Mock
}

// Call provides a mock function with given fields: req
func (_m *MockActors) Call(ctx context.Context, req *v1.InvokeMethodRequest) (*v1.InvokeMethodResponse, error) {
	ret := _m.Called(req)

	var r0 *v1.InvokeMethodResponse
	if rf, ok := ret.Get(0).(func(*v1.InvokeMethodRequest) *v1.InvokeMethodResponse); ok {
		r0 = rf(req)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*v1.InvokeMethodResponse)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(*v1.InvokeMethodRequest) error); ok {
		r1 = rf(req)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateReminder provides a mock function with given fields: req
func (_m *MockActors) CreateReminder(ctx context.Context, req *CreateReminderRequest) error {
	ret := _m.Called(req)

	var r0 error
	if rf, ok := ret.Get(0).(func(*CreateReminderRequest) error); ok {
		r0 = rf(req)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// RenameReminder provides a mock function with given fields: req
func (_m *MockActors) RenameReminder(ctx context.Context, req *RenameReminderRequest) error {
	ret := _m.Called(req)

	var r0 error
	if rf, ok := ret.Get(0).(func(request *RenameReminderRequest) error); ok {
		r0 = rf(req)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// IsActorHosted provides a mock function with given fields: req
func (_m *MockActors) IsActorHosted(ctx context.Context, req *ActorHostedRequest) bool {
	ret := _m.Called(req)

	var r0 bool
	if rf, ok := ret.Get(0).(func(*ActorHostedRequest) bool); ok {
		r0 = rf(req)
	} else {
		r0 = true
	}

	return r0
}

// CreateTimer provides a mock function with given fields: req
func (_m *MockActors) CreateTimer(ctx context.Context, req *CreateTimerRequest) error {
	ret := _m.Called(req)

	var r0 error
	if rf, ok := ret.Get(0).(func(*CreateTimerRequest) error); ok {
		r0 = rf(req)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// DeleteReminder provides a mock function with given fields: req
func (_m *MockActors) DeleteReminder(ctx context.Context, req *DeleteReminderRequest) error {
	ret := _m.Called(req)

	var r0 error
	if rf, ok := ret.Get(0).(func(*DeleteReminderRequest) error); ok {
		r0 = rf(req)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// DeleteTimer provides a mock function with given fields: req
func (_m *MockActors) DeleteTimer(ctx context.Context, req *DeleteTimerRequest) error {
	ret := _m.Called(req)

	var r0 error
	if rf, ok := ret.Get(0).(func(*DeleteTimerRequest) error); ok {
		r0 = rf(req)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetState provides a mock function with given fields: req
func (_m *MockActors) GetState(ctx context.Context, req *GetStateRequest) (*StateResponse, error) {
	ret := _m.Called(req)

	var r0 *StateResponse
	if rf, ok := ret.Get(0).(func(*GetStateRequest) *StateResponse); ok {
		r0 = rf(req)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*StateResponse)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(*GetStateRequest) error); ok {
		r1 = rf(req)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Init provides a mock function with given fields:
func (_m *MockActors) Init() error {
	ret := _m.Called()

	var r0 error
	if rf, ok := ret.Get(0).(func() error); ok {
		r0 = rf()
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Stop provides a mock function with given fields:
func (_m *MockActors) Stop() {
	_m.Called()
}

// TransactionalStateOperation provides a mock function with given fields: req
func (_m *MockActors) TransactionalStateOperation(ctx context.Context, req *TransactionalRequest) error {
	ret := _m.Called(req)

	var r0 error
	if rf, ok := ret.Get(0).(func(*TransactionalRequest) error); ok {
		r0 = rf(req)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetReminder provides a mock function with given fields: req
func (_m *MockActors) GetReminder(ctx context.Context, req *GetReminderRequest) (*Reminder, error) {
	ret := _m.Called(req)

	var r0 *Reminder
	if rf, ok := ret.Get(0).(func(*GetReminderRequest) *Reminder); ok {
		r0 = rf(req)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*Reminder)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(*GetReminderRequest) error); ok {
		r1 = rf(req)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetActiveActorsCount provides a mock function
func (_m *MockActors) GetActiveActorsCount(ctx context.Context) []ActiveActorsCount {
	_m.Called()
	return []ActiveActorsCount{
		{
			Type:  "abcd",
			Count: 10,
		},
		{
			Type:  "xyz",
			Count: 5,
		},
	}
}

type FailingActors struct {
	Failure daprt.Failure
}

func (f *FailingActors) Call(ctx context.Context, req *v1.InvokeMethodRequest) (*v1.InvokeMethodResponse, error) {
	if err := f.Failure.PerformFailure(req.Actor().ActorId); err != nil {
		return nil, err
	}
	resp := v1.NewInvokeMethodResponse(200, "Success", nil)
	return resp, nil
}

func (f *FailingActors) Init() error {
	return nil
}

func (f *FailingActors) Stop() {
}

func (f *FailingActors) GetState(ctx context.Context, req *GetStateRequest) (*StateResponse, error) {
	return nil, nil
}

func (f *FailingActors) TransactionalStateOperation(ctx context.Context, req *TransactionalRequest) error {
	return nil
}

func (f *FailingActors) GetReminder(ctx context.Context, req *GetReminderRequest) (*Reminder, error) {
	return nil, nil
}

func (f *FailingActors) CreateReminder(ctx context.Context, req *CreateReminderRequest) error {
	return nil
}

func (f *FailingActors) DeleteReminder(ctx context.Context, req *DeleteReminderRequest) error {
	return nil
}

func (f *FailingActors) RenameReminder(ctx context.Context, req *RenameReminderRequest) error {
	return nil
}

func (f *FailingActors) CreateTimer(ctx context.Context, req *CreateTimerRequest) error {
	return nil
}

func (f *FailingActors) DeleteTimer(ctx context.Context, req *DeleteTimerRequest) error {
	return nil
}

func (f *FailingActors) IsActorHosted(ctx context.Context, req *ActorHostedRequest) bool {
	return true
}

func (f *FailingActors) GetActiveActorsCount(ctx context.Context) []ActiveActorsCount {
	return []ActiveActorsCount{}
}
